diff --git a/include/mk/automake.mk b/include/mk/automake.mk
index 3ecdd3144..0fa059f11 100644
--- a/include/mk/automake.mk
+++ b/include/mk/automake.mk
@@ -27,15 +27,10 @@ AUTOHEADER	?= autoheader
 AUTOMAKE	?= automake
 
 AUTOCONFED_SUBDIRS	= \
-			testcases/realtime \
 			testcases/open_posix_testsuite
 
 # We want to run this every single time to ensure that all of the prereq files
 # are there.
-.PHONY: testcases/realtime/configure
-testcases/realtime/configure:
-	$(MAKE) -C $(@D) autotools
-
 .PHONY: testcases/open_posix_testsuite/configure
 testcases/open_posix_testsuite/configure:
 	$(MAKE) -C $(@D) autotools
diff --git a/testcases/realtime/Makefile b/testcases/realtime/Makefile
index 61663bfd9..b90ecf8c4 100644
--- a/testcases/realtime/Makefile
+++ b/testcases/realtime/Makefile
@@ -22,74 +22,12 @@
 
 top_srcdir		?= ../..
 
-# Override these variables to use non-system available tools.
-ACLOCAL			?= aclocal
-AUTOCONF		?= autoconf
-AUTOHEADER		?= autoheader
-AUTOMAKE		?= automake
-
 include $(top_srcdir)/include/mk/env_pre.mk
-# Ensure that this error / warning only applies for build targets.
-#
-# NOTE (garrcoop): this criterium should be in-sync with include/mk/env_pre.mk
-# (minus help as that's only invoked in the top-level Makefile).
-ifeq ($(filter autotools %clean .gitignore gitignore.%,$(MAKECMDGOALS)),)
-include $(abs_srcdir)/config.mk
-endif
 
 LIBDIR			:= lib
-FILTER_OUT_DIRS		:= $(LIBDIR) m4
+FILTER_OUT_DIRS		:= $(LIBDIR)
 LIB			:= $(LIBDIR)/librealtime.a
 
-# START autotools junk
-AUTOGENERATED_FILES	= \
-			m4/Makefile
-
-AUTOMAKE_FILES := config.guess config.sub install-sh missing stamp-h1
-
-.PHONY: autotools aclocal autoconf autoheader automake
-autotools: aclocal autoconf autoheader automake
-
-.PHONY: ac-clean ac-distclean ac-maintainer-clean
-ac-clean::
-	$(RM) -rf autom4te.cache
-	$(RM) -f aclocal.m4 config.log config.status
-	$(RM) -f include/realtime_config.h include/stamp-h1
-
-ac-distclean:: ac-clean
-ac-maintainer-clean:: ac-distclean
-	$(RM) -f aclocal.m4 configure $(AUTOMAKE_FILES) m4/Makefile.in
-	$(RM) -f include/realtime_config.h.in
-
-aclocal.m4:
-	$(ACLOCAL) -I $(abs_srcdir)/m4
-
-autoconf: configure
-
-include/realtime_config.h.in: configure.ac $(wildcard m4/*.m4) aclocal.m4
-	$(AUTOHEADER)
-
-configure: configure.ac aclocal.m4
-	$(AUTOCONF)
-automake: $(AUTOMAKE_FILES)
-$(AUTOMAKE_FILES): m4/Makefile.in
-m4/Makefile.in: m4/Makefile.am aclocal.m4
-	$(AUTOMAKE) -c -a
-
-.PHONY: autoheader
-autoheader: include/realtime_config.h.in
-	$(AUTOHEADER)
-
-distclean:: %: clean ac-distclean
-	$(RM) -f $(AUTOGENERATED_FILES)
-
-maintainer-clean:: distclean ac-maintainer-clean
-
-$(AUTOGENERATED_FILES): $(top_builddir)/config.status
-	$(SHELL) $^
-
-# END autotools junk
-
 $(LIBDIR):
 	mkdir -p "$@"
 
diff --git a/testcases/realtime/configure.ac b/testcases/realtime/configure.ac
deleted file mode 100644
index 6f50f1490..000000000
--- a/testcases/realtime/configure.ac
+++ /dev/null
@@ -1,42 +0,0 @@
-AC_PREREQ(2.61)
-AC_INIT([realtime],[realtime-20090930],[ltp-results@lists.sourceforge.net])
-AC_CONFIG_AUX_DIR([.])
-AM_INIT_AUTOMAKE
-AC_CONFIG_HEADERS([include/realtime_config.h])
-AC_CONFIG_FILES([   \
-	m4/Makefile \
-])
-AC_CHECK_HEADERS_ONCE([ \
-	pthread.h \
-])
-AC_CANONICAL_HOST
-
-AC_PROG_CC
-# <= autoconf 2.61 doesn't have AC_PROG_AR, but 2.63 has it. Not sure about
-# 2.62.
-AC_DEFUN([AC_PROG_AR], [AC_CHECK_TOOL(AR, ar, :)])
-AC_PROG_AR
-AC_PROG_RANLIB
-
-AC_MSG_CHECKING([for __sync_add_and_fetch gcc builtin function])
-AC_LINK_IFELSE([AC_LANG_SOURCE([
-#ifndef _GNU_SOURCE
-#define _GNU_SOURCE
-#endif
-#include <stdlib.h>
-int main(void) {
-	char *c;
-	return __sync_add_and_fetch(c, 1);
-}])],[has___sync_add_and_fetch=yes])
-if test "x$has___sync_add_and_fetch" = xyes; then
-	AC_DEFINE(HAVE___SYNC_ADD_AND_FETCH,1,[Define to 1 if you have the __sync_add_and_fetch gcc builtin function])
-	AC_MSG_RESULT(yes)
-else
-	AC_MSG_RESULT(no)
-fi
-
-AC_CHECK_LIB([m], [exp10], [AC_DEFINE([HAVE_EXP10], 1, [Define to 1 if you have exp10 function])])
-
-REALTIME_CHECK_PRIO_INHERIT
-
-AC_OUTPUT
diff --git a/testcases/realtime/include/librttest.h b/testcases/realtime/include/librttest.h
index 8e3421869..8733479e7 100644
--- a/testcases/realtime/include/librttest.h
+++ b/testcases/realtime/include/librttest.h
@@ -56,7 +56,6 @@
 #include <time.h>
 #include <unistd.h>
 #include "list.h"
-#include "realtime_config.h"
 
 extern void setup(void);
 extern void cleanup(int i);
@@ -113,15 +112,9 @@ extern double pass_criteria;
  */
 static inline int atomic_add(int i, atomic_t *v)
 {
-	/* XXX (garrcoop): only available in later versions of gcc */
-#if HAVE___SYNC_ADD_AND_FETCH
 	return __sync_add_and_fetch(&v->counter, i);
-#else
-	printf("%s: %s\n", __func__, strerror(ENOSYS));
-	exit(1);
-	return -1;
-#endif
 }
+
 /* atomic_inc: atomically increment the integer passed by reference
  */
 static inline int atomic_inc(atomic_t *v)
diff --git a/testcases/realtime/lib/libstats.c b/testcases/realtime/lib/libstats.c
index f12d618f4..96090bd15 100644
--- a/testcases/realtime/lib/libstats.c
+++ b/testcases/realtime/lib/libstats.c
@@ -46,12 +46,6 @@
 #include <libstats.h>
 #include <librttest.h>
 
-#include "../include/realtime_config.h"
-
-#ifndef HAVE_EXP10
-# define exp10(x) (exp((x) * log(10)))
-#endif
-
 int save_stats = 0;
 
 /* static helper functions */
diff --git a/testcases/realtime/m4/.gitignore b/testcases/realtime/m4/.gitignore
deleted file mode 100644
index 5fc607b9e..000000000
--- a/testcases/realtime/m4/.gitignore
+++ /dev/null
@@ -1 +0,0 @@
-/Makefile
diff --git a/testcases/realtime/m4/GNUmakefile b/testcases/realtime/m4/GNUmakefile
deleted file mode 100644
index 2a5b4c613..000000000
--- a/testcases/realtime/m4/GNUmakefile
+++ /dev/null
@@ -1,37 +0,0 @@
-#
-#    m4 Makefile.
-#
-#    Copyright (C) 2009, Cisco Systems Inc.
-#
-#    This program is free software; you can redistribute it and/or modify
-#    it under the terms of the GNU General Public License as published by
-#    the Free Software Foundation; either version 2 of the License, or
-#    (at your option) any later version.
-#
-#    This program is distributed in the hope that it will be useful,
-#    but WITHOUT ANY WARRANTY; without even the implied warranty of
-#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#    GNU General Public License for more details.
-#
-#    You should have received a copy of the GNU General Public License along
-#    with this program; if not, write to the Free Software Foundation, Inc.,
-#    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
-#
-# Ngie Cooper, July 2009
-#
-
-top_srcdir		?= ../../..
-
-include $(top_srcdir)/include/mk/env_pre.mk
-
-M4MACROS		:= $(notdir $(wildcard *.m4))
-
-INSTALL_DIR		:= $(datarootdir)/aclocal
-
-INSTALL_MODE		:= 00644
-
-INSTALL_TARGETS		:= $(M4_MACROS)
-
-MAKE_TARGETS		:=
-
-include $(top_srcdir)/include/mk/generic_leaf_target.mk
diff --git a/testcases/realtime/m4/Makefile.am b/testcases/realtime/m4/Makefile.am
deleted file mode 100644
index 87c304b42..000000000
--- a/testcases/realtime/m4/Makefile.am
+++ /dev/null
@@ -1 +0,0 @@
-# bogus makefile to appease automake
diff --git a/testcases/realtime/m4/check.m4 b/testcases/realtime/m4/check.m4
deleted file mode 100644
index d04a2cc73..000000000
--- a/testcases/realtime/m4/check.m4
+++ /dev/null
@@ -1,14 +0,0 @@
-AC_DEFUN([REALTIME_CHECK_PRIO_INHERIT],[
-AC_MSG_CHECKING([for PTHREAD_PRIO_INHERIT])
-AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
-#include <pthread.h>]], [[int main(void) {
-	pthread_mutexattr_t attr;
-	return pthread_mutexattr_setprotocol(&attr, PTHREAD_PRIO_INHERIT);
-}]])],[has_priority_inherit="yes"],[])
-if test "x$has_priority_inherit" = "xyes" ; then
-	AC_DEFINE(HAS_PRIORITY_INHERIT,1,[Define to 1 if you have PTHREAD_PRIO_INHERIT])
-	AC_MSG_RESULT(yes)
-else
-	AC_MSG_RESULT(no)
-fi
-])